<script setup lang="ts">
import { usePromotionStore } from '@/stores/promotion';
import { ref } from 'vue';
import PromoDialogDetele from './PromoDialogDetele.vue';
import PromoDialogType1 from './PromoDialogType1.vue';
import PromoDialogType2 from './PromoDialogType2.vue';
import PromoDialogType3 from './PromoDialogType3.vue';
import PromoDialogType from './PromoDialogType.vue';
import type { Promotion } from '@/types/Promotion';
import type { PromotionDetail } from '@/types/PromotionDetail';
const promoStore = usePromotionStore()

promoStore.promotions.sort((a, b) => a.id! - b.id!)
function formatDate(date :Date |any): string{
  const year = date.getFullYear();
  const month = String(date.getMonth() + 1).padStart(2, '0'); // เพิ่ม 1 เพราะเดือนเริ่มจาก 0
  const day = String(date.getDate()).padStart(2, '0');
  const formattedDate = `${year}-${month}-${day}`;
  return formattedDate;
}
const  headers =[
          {
            key: 'id',
            sortable: false,
            title: 'Id',
          },
          { key: 'name', title: 'Name' },
          { key: 'condition', title: 'Condition' },
          { key: 'start', title: 'Start',value:(item: any) => {
            return item.start.substring(0, 10);

          } },
          { key: 'end', title: 'End', value:(item:any)=>{
            return item.end.substring(0, 10);
          } },
          { key: 'status', title: 'Status' },
          { key: 'discount', title: 'Discount',value:(item: any)=>{
            if(item.discount<1){
              return item.discount*100+"%"
            }
            return item.discount
          }},
          {
    key: 'promotionDetail',
    title: 'Product',
    value: (item: any | Promotion) => {
      // ตรวจสอบว่า item.promotionDetail มีค่าหรือไม่
      if (item.promotionDetail && item.promotionDetail.length > 0) {
        // นำ productName ทุกตัวมาต่อกันและคั่นด้วยเครื่องหมาย ","
        
        return item.promotionDetail.map((detail: PromotionDetail) => detail.productName).join(', ');
      }
      return 'ไอ้โง่แบงค์'
      // ถ้าไม่มี item.promotionDetail หรือเป็น array ว่าง ให้คืนค่าเป็น string ว่าง
    },
  },
          { title: 'Actions', key: 'actions', sortable: false },
        ]
</script>

<template>
    <v-data-table 
            :headers="headers"
            :items="promoStore.promotions"
            :search="promoStore.search"
            :items-per-page="8"
            style="background-color: #E7D0B9;"
            
            >

            <template v-slot:[`item.actions`]="{ item }">
      <v-icon
        size="small"
        class="me-2"
        @click="promoStore.editPromotion(item.id!)"
      >
        mdi-pencil
      </v-icon>
      <v-icon
        size="small"
        @click="promoStore.openDialogDelete(item.id!)"
      >
        mdi-delete
      </v-icon>
    </template>
</v-data-table>

<PromoDialogDetele></PromoDialogDetele>
<PromoDialogType1></PromoDialogType1>
<PromoDialogType2></PromoDialogType2>
<PromoDialogType3></PromoDialogType3>
<PromoDialogType></PromoDialogType>
</template>
<style scoped>
  tbody tr:nth-of-type(even) {
    background-color: #D2BAA0;
  }

  tbody tr:nth-of-type(odd) {
    background-color: #E7D0B9;
  }

  thead {
    background-color: #BC9B6B;
    color: rgb(0, 0, 0);
    font-weight: bold;
  }


  .theme--light.v-data-table thead tr th {
    color: white;
  }
  
  
</style>